import sqlite3 as sqlite
import json
import os

from common_variables import PRINT_DEBUG

def print_deg(print_str):
    if PRINT_DEBUG == 1:
        print(print_str)

#检索数据库，将itemlist生成json格式字符串保存到临时文件中
def get_itemlistfromsql():
    db_dir = "/opt/kydoctor/common/db/" #数据库路径
    #db_dir = "./"
    db_dir_path = db_dir+"solution.db"
    if not os.path.exists(db_dir_path):
        print_deg("solution.db not exist!")
        return -1

    con = sqlite.connect(db_dir_path)
    try:
        my_dict = {}
        with con:
            cur = con.cursor()
            cur.execute("select * from checkitemlist")
            rows = cur.fetchall()
            for row in rows:
                table_temp = []
                table_temp.append(row[2])
                table_temp.append(row[3])
                table_temp.append(row[4])
                if row[1] not in my_dict:
                    my_dict[row[1]] = [table_temp]
                else:
                    my_dict[row[1]].append(table_temp)
            print_deg("my_dict = "+str(my_dict))

        json_table = []
        for key,item in my_dict.items():
            dict_temp = {}
            dict_temp["Category"] = key
            types_table = []
            #types_dict = {}
            for t1_item in item:
                #for t2_num in len(t1_item):
                #print("t1_item = ",t1_item)
                type_dict = {}
                type_dict["Type"] = t1_item[0]
                type_dict["Name"] = t1_item[1]
                type_dict["Describe"] = t1_item[2]
                types_table.append(type_dict)
            dict_temp["Types"] = types_table
            json_table.append(dict_temp)

        print_deg("str === "+str(json_table))
        #print(json.dumps(json_table))
        json_table_str = json.dumps(json_table)

        #开始往临时文件中写数据
        report_result_name = "/tmp/kydoctor"
        result_fd = open(report_result_name,"w")
        result_fd.write(json_table_str)
        result_fd.close()
                            
        #return -1
    except Exception as e:
        print("in get_itemlist,error :",e)
        return -1
    return 0
    pass
def get_itemlistfromtxt():
    des_log_path = "/tmp/kydoctor_log"
    if os.path.exists(des_log_path):
        os.remove(des_log_path) 
    db_dir_path = "/tmp/kydoctor_c_sql"
    if not os.path.exists(db_dir_path):
        print_deg("/tmp/kydoctor_c_sql not exist!")
        return -1

    try:
        my_dict = {}
        file1 = open(db_dir_path)
        while True:
            text = file1.readline()
            if len(text) == 0:
                break
            row = text.split("+++")
            table_temp = []
            table_temp.append(row[2])
            table_temp.append(row[3])
            table_temp.append(row[4])
            if row[1] not in my_dict:
                my_dict[row[1]] = [table_temp]
            else:
                my_dict[row[1]].append(table_temp)
        print_deg("my_dict = "+str(my_dict))

        json_table = []
        for key,item in my_dict.items():
            dict_temp = {}
            dict_temp["Category"] = key
            types_table = []
            #types_dict = {}
            for t1_item in item:
                #for t2_num in len(t1_item):
                #print("t1_item = ",t1_item)
                type_dict = {}
                type_dict["Type"] = t1_item[0]
                type_dict["Name"] = t1_item[1]
                type_dict["Describe"] = t1_item[2]
                types_table.append(type_dict)
            dict_temp["Types"] = types_table
            json_table.append(dict_temp)

        print_deg("str === "+str(json_table))
        #print(json.dumps(json_table))
        json_table_str = json.dumps(json_table)

        #开始往临时文件中写数据
        report_result_name = "/tmp/kydoctor"
        result_fd = open(report_result_name,"w")
        result_fd.write(json_table_str)
        result_fd.close()
        file1.close()                   
        #return -1
    except Exception as e:
        if os.path.exists(db_dir_path):
            os.remove(db_dir_path)
        print("in get_itemlist,error :",e)
        return -1
    if os.path.exists(db_dir_path):
        os.remove(db_dir_path)
    return 0
    pass
def get_newdesign_itemlistfromtxt():
    des_log_path = "/tmp/kydoctor_log"
    if os.path.exists(des_log_path):
        os.remove(des_log_path) 
    db_dir_path = "/tmp/kydoctor_c_sql"
    if not os.path.exists(db_dir_path):
        print("/tmp/kydoctor_c_sql not exist!")
        return -1
    #print("i am in ")
    json_table = []

    json_dict_classa_1 = {"class_a":"网络检测"}
    json_dict_classa_2 = {"class_a":"系统组件与性能检测"}
    json_dict_classa_3 = {"class_a":"应用程序检测"}


    json_table_classb_1 = []
    json_table_classb_2 = []
    json_table_classb_3 = []

    try:
        file1 = open(db_dir_path)
        while True:
            text = file1.readline()
            if len(text) == 0:
                break
            text = text.rstrip("\n")
            row = text.split("+++")
            if len(row) < 4:
                continue
            print("row = ",row)
            #解析每一行，如果其一级标题==等于“网络检测”
            if str(row[1]) == "网络检测":
                #拿到二级标题，解析json_table_classb_1下面所有的字典，判断二级标题是否等于其"Name"值
                temp_class2_equal = 0
                for temp_dict2 in json_table_classb_1:
                    if temp_dict2["Name"] == str(row[2]):
                        temp_class2_equal = 1
                        #2:找到一个等于，如果三级标题不为空，则遍历for temp in json_table_classb_1[i]["class_c"]下面的所有字典，判断
                        #三级标题是否等于temp["Name"],没有的话 则新增，有的话退出
                        if str(row[4]) != "":
                            temp_class3_equal = 0
                            for temp_dict3 in temp_dict2["class_c"]:
                                if row[4] == temp_dict3["Name"]:
                                    temp_class3_equal = 1
                                    break
                            if temp_class3_equal == 0:
                                temp_dict4={}
                                temp_dict4["Name"] = str(row[4])
                                temp_dict4["Describe"] = str(row[5])
                                temp_dict2["class_c"].append(temp_dict4)
                                #print("2------------- json_table_classb_1 = ",json_table_classb_1)
                #1：都不等于，则新建一个临时dict2={"Name"=二级标题，"Descripe"="描述"}，并且判断三级标题是否为空
                #不为空则dict2["class_c"] = [],dict3 = {"Name"=三级标题，"Descripe"="描述"}
                #为空的话dict2["class_c"] = []，插入到json_table_classb_1
                if temp_class2_equal == 0:
                    temp_dict2 = {}
                    temp_dict2["Name"] = str(row[2])
                    temp_dict2["Describe"] = str(row[3])
                    temp_dict2["class_b_id"] = str(row[6])
                    temp_dict2["class_c"] = []
                    temp_dict3_1 = {}
                    if str(row[4]) != "":
                        temp_dict3_1["Name"] = str(row[4])
                        temp_dict3_1["Describe"] = str(row[5])
                    temp_dict2["class_c"].append(temp_dict3_1)
                    json_table_classb_1.append(temp_dict2)
                    #print("1------------- json_table_classb_1 = ",json_table_classb_1)                                    
            elif row[1] == "系统组件与性能检测":
                 #拿到二级标题，解析json_table_classb_2下面所有的字典，判断二级标题是否等于其"Name"值
                temp_class2_equal = 0
                for temp_dict2 in json_table_classb_2:
                    if temp_dict2["Name"] == str(row[2]):
                        temp_class2_equal = 1
                        #2:找到一个等于，如果三级标题不为空，则遍历for temp in json_table_classb_2[i]["class_c"]下面的所有字典，判断
                        #三级标题是否等于temp["Name"],没有的话 则新增，有的话退出
                        if str(row[4]) != "":
                            temp_class3_equal = 0
                            for temp_dict3 in temp_dict2["class_c"]:
                                if row[4] == temp_dict3["Name"]:
                                    temp_class3_equal = 1
                                    break
                            if temp_class3_equal == 0:
                                temp_dict4={}
                                temp_dict4["Name"] = str(row[4])
                                temp_dict4["Describe"] = str(row[5])
                                temp_dict2["class_c"].append(temp_dict4)
                                #print("2------------- json_table_classb_2 = ",json_table_classb_2)
                #1：都不等于，则新建一个临时dict2={"Name"=二级标题，"Descripe"="描述"}，并且判断三级标题是否为空
                #不为空则dict2["class_c"] = [],dict3 = {"Name"=三级标题，"Descripe"="描述"}
                #为空的话dict2["class_c"] = []，插入到json_table_classb_2
                if temp_class2_equal == 0:
                    temp_dict2 = {}
                    temp_dict2["Name"] = str(row[2])
                    temp_dict2["Describe"] = str(row[3])
                    temp_dict2["class_b_id"] = str(row[6])
                    temp_dict2["class_c"] = []
                    temp_dict3_1 = {}
                    if str(row[4]) != "":
                        temp_dict3_1["Name"] = str(row[4])
                        temp_dict3_1["Describe"] = str(row[5])
                    temp_dict2["class_c"].append(temp_dict3_1)
                    json_table_classb_2.append(temp_dict2)
                    #print("1------------- json_table_classb_2 = ",json_table_classb_2)
                pass
            elif row[1] == "应用程序检测":
                 #拿到二级标题，解析json_table_classb_3下面所有的字典，判断二级标题是否等于其"Name"值
                temp_class2_equal = 0
                for temp_dict2 in json_table_classb_3:
                    if temp_dict2["Name"] == str(row[2]):
                        temp_class2_equal = 1
                        #2:找到一个等于，如果三级标题不为空，则遍历for temp in json_table_classb_3[i]["class_c"]下面的所有字典，判断
                        #三级标题是否等于temp["Name"],没有的话 则新增，有的话退出
                        if str(row[4]) != "":
                            temp_class3_equal = 0
                            for temp_dict3 in temp_dict2["class_c"]:
                                if row[4] == temp_dict3["Name"]:
                                    temp_class3_equal = 1
                                    break
                            if temp_class3_equal == 0:
                                temp_dict4={}
                                temp_dict4["Name"] = str(row[4])
                                temp_dict4["Describe"] = str(row[5])
                                temp_dict2["class_c"].append(temp_dict4)
                                #print("2------------- json_table_classb_3 = ",json_table_classb_3)
                #1：都不等于，则新建一个临时dict2={"Name"=二级标题，"Descripe"="描述"}，并且判断三级标题是否为空
                #不为空则dict2["class_c"] = [],dict3 = {"Name"=三级标题，"Descripe"="描述"}
                #为空的话dict2["class_c"] = []，插入到json_table_classb_3
                if temp_class2_equal == 0:
                    temp_dict2 = {}
                    temp_dict2["Name"] = str(row[2])
                    temp_dict2["Describe"] = str(row[3])
                    temp_dict2["class_b_id"] = str(row[6])
                    temp_dict2["class_c"] = []
                    temp_dict3_1 = {}
                    if str(row[4]) != "":
                        temp_dict3_1["Name"] = str(row[4])
                        temp_dict3_1["Describe"] = str(row[5])
                    temp_dict2["class_c"].append(temp_dict3_1)
                    json_table_classb_3.append(temp_dict2)
                    #print("1------------- json_table_classb_3 = ",json_table_classb_3)
                pass

    except Exception as e:
        if os.path.exists(db_dir_path):
            os.remove(db_dir_path)
        print("e = ",e)
        return -1
    json_dict_classa_1["class_b"] = json_table_classb_1
    json_dict_classa_2["class_b"] = json_table_classb_2
    json_dict_classa_3["class_b"] = json_table_classb_3
    #最后
    json_table.append(json_dict_classa_1)
    json_table.append(json_dict_classa_2)
    json_table.append(json_dict_classa_3)

    print_deg("55------------- json_table = "+str(json_table))
    json_table_str = json.dumps(json_table)

    #开始往临时文件中写数据
    report_result_name = "/tmp/kydoctor"
    result_fd = open(report_result_name,"w")
    result_fd.write(json_table_str)
    result_fd.close()
    file1.close()
    if os.path.exists(db_dir_path):
        os.remove(db_dir_path)
    return 0
if __name__ == "__main__":
    #ret = get_itemlistfromsql() 
    #ret = get_itemlistfromtxt()
    ret = get_newdesign_itemlistfromtxt()
    if ret == -1:
        exit(-1)
    else:
        exit(0)


